function disp(pop, gen)
%
%
global tracking;

if pop.algo.batch_mode == 0
    id = pop.rank(1);
    if pop.feas(id) ~= 1
        id2 = find(pop.feas == 1, 1);
        if ~isempty(id2)
            id = id2;
        end
    end
    
	fprintf('Generation %d\n', gen);
	mesg = '';
	for i = 1:pop.prob.nf
		tmp = sprintf(' %g', pop.f(id,i));
		mesg = strcat(mesg, tmp);
	end
	fprintf('\tObjectives: [%s ]\n', mesg);
	mesg = '';
	for i = 1:pop.prob.ng
		tmp = sprintf(' %g', pop.g(id,i));
		mesg = strcat(mesg, tmp);
	end
	fprintf('\tConstraints: [%s ]\n', mesg);
	mesg = '';
	for i = 1:pop.prob.nx
		tmp = sprintf(' %g', pop.x(pop.rank(1),i));
		mesg = strcat(mesg, tmp);
	end
	fprintf('\tDesign: [%s ]\n', mesg);
	fprintf('\tNon-Dominated: %d\n', pop.f1size);
	fprintf('\tFeasible: %d (%d)\n', sum(pop.feas), sum(pop.flag));

	if tracking == 1
		fprintf('\tTracking: %d/%d %d/%d/%d %d\n', ...
			pop.track_best(gen,1), pop.track_best(gen,2), ...
			pop.track_best(gen,3), pop.track_best(gen,4), ...
			pop.track_best(gen,5), pop.track_best(gen,6));
	end
end

return
