function [ranks, dist] = epsdom_sort(pop, data, front)

F = data.F;
M = pop.prob.nf;
L = length(F(front).f);

dist = zeros(L,1);
for i =  1:L
    dist(i) = Inf;
    id1 = F(front).f(i);
    for j = 1:L
        if j~=i
            id2=F(front).f(j);
            v = mepsd(pop,id1,id2);
            if dist(i)> v 
                dist(i) = v;
            end
        end
    end
end


[tmp,I] = sort(dist,'descend');
ranks = F(front).f(I(:));

return

function [mepsd] = mepsd(pop,id1,id2)
[ids] = find(pop.f(id2,:)>pop.f(id1,:));
mepsd = max(pop.f(id2,ids)-pop.f(id1,ids));
return