function [childpop] = evolve(pop, user_data)
% EVOLVE(pop, user_data)
%		evolve(pop, user_data) Wrapper for all the evolution methods

if nargin == 1
	user_data = [];
end

if ~isempty(pop.algo.evolve_method)
	evolve_func = strcat('evolve_', pop.algo.evolve_method);
	childpop = feval(evolve_func, pop, user_data);
else
	error('Evolution Strategy (evolve_method) not defined');
end
return
