function childpop = evolve_sqp(pop,Np)

global f_func w 
global counter
global sqp_count
global sqp_gen

Np = 5;

f_func = pop.prob.func;

% childpop = population(pop);
% childpop.x = pop.x;
% childpop.f = pop.f;
% childpop.feas = pop.feas;
childpop = pop;

f_func = pop.prob.func;
ids_sqp = randint(Np,1,[1 pop.size]);
ids_sqp = [1:Np];

lb = pop.prob.range(:,1);
ub = pop.prob.range(:,2);

for i = 1:length(ids_sqp)
    id = ids_sqp(i);
    w = rand(1,pop.prob.nf);
%     w = ones(1,pop.prob.nf);
    w = w/sum(w);
    x0 = pop.x(id,:);
%     keyboard
    [xopt(i,:), fopt(i,:),fl,o] = fmincon(@scale_func,x0, [], [], [], [], lb, ub, []);
    [ftrue(i,:),gtrue] = feval(f_func,xopt(i,:));
    sqp_count = sqp_count+o.funcCount;
    counter.fn_evals = counter.fn_evals+o.funcCount;
end

% keyboard
childpop.x(end-Np+1:end,:) = xopt;
childpop.f(end-Np+1:end,:) = ftrue;

figure(1);
hold on
plot(ftrue(:,1),ftrue(:,2),'ro','MarkerSize',15);
hold off

fp = fopen('sqp_sols.dat','a');
write_to_file([repmat(sqp_gen,Np,1) ftrue],fp);
fclose(fp);

return


%
% Binary Tournament 
%
function parent = tournament(pop, id1, id2)
if pop.rank(id1) < pop.rank(id2)
	parent = id1;
elseif pop.rank(id2) < pop.rank(id1)
	parent = id2;
elseif rand(1) <= 0.5
	parent = id1;
else
	parent = id2;
end
return


%
% Recombination 
%
function [c1, c2] = recombination(pop, id1, id2, range, nx, idx)

c1 = zeros(nx, 1);
c2 = zeros(nx, 1);
% size(c1)

prob_re = pop.algo.prob_re;
eta_re = pop.algo.eta_re;

if rand(1) <= prob_re
    for i = 1:length(idx)
		if rand(1) <= 0.5
			[y1, y2] = op_SBX(pop.x(id1,idx(i)), pop.x(id2,idx(i)), ...
					range(idx(i),1), range(idx(i),2), eta_re);
		else
			y1 = pop.x(id1,idx(i));
			y2 = pop.x(id2,idx(i));
		end
		c1(idx(i)) = y1;
		c2(idx(i)) = y2;
    end
else
    c1 = pop.x(id1,:);
    c2 = pop.x(id2,:);
end

return


%
% Mutation
%
function pop = mutation(pop, range, idx)
prob_mu = pop.algo.prob_mu;
eta_mu = pop.algo.eta_mu;

for i = 1:pop.size
    for j = 1:length(idx)
        x_min = range(idx(j),1);
    	x_max = range(idx(j),2);	
		if rand(1) <= prob_mu
			pop.x(i,idx(j)) = op_MUTATE(pop.x(i,idx(j)), x_min, x_max, eta_mu);
		end
	end
end
return

function [f] = scale_func(x)

global w f_func;
[ftrue,gtrue] = feval(f_func,x);
f = w*ftrue';
% g = gtrue;

return
