function [ranks, dist] = fpd_sort(pop, data, front)

F = data.F;
% M = pop.prob.nf;
L = length(F(front).f);

dist = zeros(L,1);
for i =  1:L
    dist(i) = 0;
    id1 = F(front).f(i);
    for j = 1:L
        if j~=i
            id2=F(front).f(j);
            v = fpd(pop,id1,id2);
            if dist(i)< v 
                dist(i) = v;
            end
        end
    end
end

[tmp,I] = sort(dist,'ascend');
ranks = F(front).f(I(:));

return

function [fpd] = fpd(pop,id1,id2)

temp = find(pop.f(id1,:)<pop.f(id2,:));
fpd = prod(pop.f(id1,temp)./pop.f(id2,temp));

return