function pop = init(pop, method)
% INIT(pop) 
%		pop = init(pop) initializes the population randomly

if nargin == 1
	method = 'uniform';
end

nx = pop.prob.nx;
range = pop.prob.range;
pop_size = pop.algo.pop_size;

switch lower(method)
	case 'uniform'
		for i = 1:nx
			x_min = range(i,1);
			x_max = range(i,2);
			for j = 1:pop_size
				pop.x(j,i) = x_min + (x_max - x_min) * rand(1);
			end
		end
	otherwise
		error('Initialization method %s not implemented', method);
	end
return
