function [F1size, data] = non_dominated_sort_1(pop, feasible)

%
%
N = length(feasible);
M = get(pop.prob, 'nf');


% Identifying first front
front = 1;
F(front).f = [];

%individual = nds_sort(N, M, feasible, pop.f(feasible(:),:));
individual = nds_sort_c(N, M, feasible, pop.f(feasible(:),:));

for i = 1:N
    id1 = feasible(i);
    if individual(id1).N == 0
        F(front).f = [F(front).f id1];
    end
end
F1size = length(F(front).f);

data = struct('individual', individual, 'F', F, 'feasible', feasible);
return


function [individual] = nds_sort(N, M, feasible, f_all)
individual = [];
for i = 1:N
    id1 = feasible(i);
    individual(id1).N = 0;
    individual(id1).S = [];
end
%for i=1:N
% 	id1 = feasible(i);
% 	for j = 1:N
%		id2 = feasible(j);
%		for k = 1:M
%			if pop.f(id1,k) <= pop.f(id2,k)
%				dom_less = dom_less + 1;
%			end
%			if pop.f(id1,k) >= pop.f(id2,k)
%				dom_more = dom_more + 1;
%			end
%			if dom_less == M && dom_more < M
%				individual(id1).S = [individual(id1).S id2];
%			elseif dom_more == M && dom_less < M
%				individual(id1).N = individual(id1).N + 1;
%			end
%		end
%	end
%end
for i = 1:N
    id1 = feasible(i);
    f = repmat(f_all(i,:), N, 1);
    dom_less = sum(f <= f_all, 2);
    dom_more = sum(f >= f_all, 2);
    for j = 1:N
        id2 = feasible(j);
        if dom_less(j) == M && dom_more(j) < M
            individual(id1).S = [individual(id1).S id2];
        elseif dom_more(j) == M && dom_less(j) < M
            individual(id1).N = individual(id1).N + 1;
        end
    end
end
return


function [individual] = nds_sort_c(N, M, feasible, f_all)
individual = [];

[indN, indS, indS_n] = ind_sort(feasible, f_all');
for i = 1:N
	id1 = feasible(i);
	individual(id1).N = indN(i);
	count = indS_n(i);
	individual(id1).S = indS(1:count,i);
end
return


function show_ind(feasible, individual, N)
for i = 1:N
	id1 = feasible(i);
	fprintf('%d: %d [ ', id1, individual(id1).N);
	for j = individual(id1).S
		fprintf('%d ', j);
	end
	fprintf(']\n');
end
return
