function plot(pop, figure_id)
% PLOT(pop) plots pareto front or pareto surface
%
if nargin == 1, figure_id = 1; end

if pop.algo.batch_mode == 0
	switch pop.prob.nf
	case 1
		figure(figure_id);
		id1 = find(pop.best.feas == 0);
		id2 = find(pop.best.feas == 1);
		plot(id1, pop.best.f(id1), 'r*', id2, pop.best.f(id2), 'b*-');
		plot_tracking(pop, 3);
	case 2
		figure(figure_id);
		id1 = find(pop.feas == 0);
		id2 = find(pop.feas == 1);
		plot(pop.f(id1,1), pop.f(id1,2), 'r*', ...
				pop.f(id2,1), pop.f(id2,2), 'b*');
	case 3
		figure(figure_id);
		id1 = find(pop.feas == 0);
		id2 = find(pop.feas == 1);
		plot3(pop.f(id1,1), pop.f(id1,2), pop.f(id1,3), 'r*', ...
				pop.f(id2,1), pop.f(id2,2), pop.f(id2,3), 'b*');
	end
	drawnow;
end
return
