function plot_tracking(pop, figure_id)

if nargin == 1, figure_id = 3; end
global tracking
if tracking == 1
	m = size(pop.track_best, 1);

	figure(figure_id);
	n = max(pop.track_best(:,2),1);
	n1 = pop.track_best(:,3) ./ n;
	n2 = pop.track_best(:,4) ./ n;
	n3 = pop.track_best(:,5) ./ n;
	id1 = find(pop.track_best(:,6) == 1);
	id2 = find(pop.track_best(:,6) == 2);
	id3 = find(pop.track_best(:,6) == 3);

	plot(1:m, n1, 'r.-', id1, n1(id1), 'r^', 'MarkerSize', 12);
    hold on;
	plot(1:m, n2, 'k.-', id2, n2(id2), 'k^', 'MarkerSize', 12);
	plot(1:m, n3, 'b.-', id3, n3(id3), 'b^', 'MarkerSize', 12);
    hold off;

	figure(figure_id+1);
	plot(1:m, pop.track_best(:,6), 'r*-');
    axis([0 m+1 -1 4]);

	drawnow;
end

return
