function pop = population(p, a)
%POPULATION Population class 
%	pop = population(prob, algo) creates empty population class from the 
%   problem structure and algorithm structure
%
if nargin == 1
	prob = p.prob;
	algo = p.algo;
elseif nargin == 2
	prob = p;
	algo = a;
end

pop.prob = prob;
pop.algo = algo;
pop.f1size = 0;

pop.size = algo.pop_size;

pop.x = zeros(pop.size, prob.nx);
pop.f = zeros(pop.size, prob.nf);
pop.g = zeros(pop.size, prob.ng);
pop.flag = zeros(pop.size, 1);
pop.feas = zeros(pop.size, 1);
pop.rank = zeros(pop.size, 1);
pop.rank1 = 0;	% corrected rank1 solution (to handle constrainted GA)

% Track the evolution of feasible/infeasible solutions
pop.tracking = zeros(pop.size, 1);
pop.track_best = [pop.size 0 0 0 0 1];

% Track the best solutions across generations
pop.best = [];

% Non-dominated fronts and crowding distance
pop.F = [];
pop.crowd = zeros(pop.size, 1);

pop = class(pop, 'population');
return
