function childpop = evolve_edaemna(pop, user_data)

childpop = population(pop);

N = round(pop.size/2);
x = pop.x(1:N, :);

[mu, sigma] = eda_estimate(x);

range = pop.prob.range;

childpop.x = mvnrnd(mu, sigma, pop.size);
for i = 1:pop.size
	for j = 1:pop.prob.nx
		if childpop.x(i,j) < range(j,1)
			childpop.x(i,j) = range(j,1);
		end
		if childpop.x(i,j) > range(j,2)
			childpop.x(i,j) = range(j,2);
		end
	end
end
return


%
% Calculation of MVN distribution
%
function [mu, sigma] = eda_estimate(x)
N = size(x,1);
nx = size(x,2);
mu = zeros(1,nx);
sigma = zeros(nx,nx);
for i = 1:nx
	mu(i) = sum(x(:,i)) / N;
end
for i = 1:nx
	tmp = x(:,i) - mu(i);
	sigma(i,i) = (tmp'*tmp) / N;
	for j = i+1:nx
		tmp2 = x(:,j) - mu(j);
		sigma(i,j) = (tmp'*tmp2) / N;
		sigma(j,i) = sigma(i,j);
	end
end
return
