function [childpop] = evolve_epsconstr(pop, user_data)

childpop = population(pop);

random_restart = pop.algo.random_restart;

if random_restart == 1
	childpop = init(childpop);
end

fmin = zeros(2, 1);
fmax = zeros(2, 1);

N = pop.size;

range = pop.prob.range;
max_iter = pop.algo.max_iter;

for i = 1:2
	if random_restart == 1
		x1 = childpop.x(randint(1,1,N)+1,:);
	else
		x1 = pop.x(randint(1,1,N)+1,:);
	end
	[x2, fmin(i), eflag] = fmincon(@(x) obj_func(x, pop, i), ...
	x1, [], [], [], [], range(:,1)', range(:,2)', [], ...
			optimset('Display', 'off', 'LargeScale', 'off', 'MaxIter', max_iter));
	childpop.x(i,:) = x2;
	fmax(3-i) = obj_func(x2, pop, 3-i);
end

% K - steps for minimizing f1
K = (N - 2) / 2;

count = 3;
for i = 1:2
	step = (fmax(i) - fmin(i)) / (K+1);
	for j = 1:K
		if random_restart == 1
			x1 = childpop.x(randint(1,1,N)+1,:);
		else
			x1 = pop.x(randint(1,1,N)+1,:);
		end
		f = fmin(i) + j*step;
		[x2, f2, eflag] = fmincon(@(x) obj_func(x, pop, 3-i), ...
				x1, [], [], [], [], range(:,1)', range(:,2)', ...
				@(x) constr_func(x, pop, i, f), ...
				optimset('Display', 'off', 'LargeScale', 'off', 'MaxIter', max_iter));
		childpop.x(count,:) = x2;
		%disp([f f2 eflag]);
		count = count+1;
	end
end

return


%
function obj = obj_func(x, pop, f_id)
[f, g] = obj_constr_eval(pop.prob.func, x, []);

flag = 0;
penalty = 0;

for i = 1:length(g)
	if g(i) < 0
		flag = 1;
		penalty = penalty + 1.e10*abs(g(i));
	end
end

if flag == 1
	obj = penalty + 1.e10;
else
	obj = f(f_id);
end

return


%
function [c, ceq] = constr_func(x, pop, f_id, fval)
[f, g] = obj_constr_eval(pop.prob.func, x, []);

c = f(f_id) - fval;
ceq = [];

return
