function childpop = evolve_subconga_sbx(pop, user_data)

% algo = paramset('sub', 'sub', 'evolve_method', 'realga');

global s_param;

algo = paramset([], []);
algo = add_param_fixed(algo, 'evolve_method', 'realga');

algo = add_param_var(algo, 'pop_size', pop.algo.pop_size, 'INT');
%algo = add_param_var(algo, 'generations', pop.algo.subea_gen, 'INT');

algo = add_param_var(algo, 'max_fn_evals', 0, 'INT');
algo = add_param_var(algo, 'prob_re', pop.algo.prob_re, 'REAL');
algo = add_param_var(algo, 'eta_re', pop.algo.eta_re, 'REAL');
algo = add_param_var(algo, 'prob_mu', pop.algo.prob_mu, 'REAL');
algo = add_param_var(algo, 'eta_mu', pop.algo.eta_mu, 'REAL');
algo = add_param_var(algo, 'strategy', pop.algo.strategy,'INT');
algo = add_param_var(algo, 'infeasible_ratio', pop.algo.infeasible_ratio,'REAL');

sub_pop = population(pop.prob, algo);
if pop.algo.random_restart == 1
	sub_pop = init(sub_pop);
else
	sub_pop.x = pop.x;
end
sub_pop = eval(sub_pop);

prob2 = convert_prob(algo.strategy,pop.prob);
sub_pop2 = population(prob2, algo); 
sub_pop2 = convert(algo.strategy, sub_pop, sub_pop2, s_param);
[sub_pop, sub_pop2] = sort_conga(sub_pop, sub_pop2);
update(algo.strategy, sub_pop, sub_pop2, 1);

subea_gen = pop.algo.subea_gen;
for i = 1:subea_gen
	sub_cpop = evolve(sub_pop);
	sub_cpop = eval(sub_cpop);
	sub_pop = sub_pop + sub_cpop;
    sub_cpop2 = population(prob2, algo);
    sub_pop2 = sub_pop2 + sub_cpop2;
    sub_pop2 = convert(algo.strategy,sub_pop,sub_pop2,s_param);
    [sub_pop, sub_pop2] = sort_conga(sub_pop, sub_pop2);
	sub_pop = reduce(sub_pop);
    sub_pop2 = reduce(sub_pop2); 
    update(algo.strategy, sub_pop, sub_pop2, i);
end

childpop = population(pop);
childpop.x = sub_pop.x;

return

%
% Convert SO problem to MO problem
%
function [prob2] = convert_prob(strategy, prob)
global c_count;
prob2 = prob;
if strategy == 1
    prob2.nf = prob.nf+1;
    prob2.ng = 1;
elseif strategy == 2
    prob2.nf = prob.nf+1;
    prob2.ng = 1;
elseif strategy == 3
    prob2.nf = prob.nf+1;
    prob2.ng = 0;
elseif strategy == 4
    prob2.nf = prob.nf+1;
    prob2.ng = 1;
elseif strategy == 5
    prob2.nf = prob.nf+1;
    prob2.ng = 0;
elseif strategy == 6
    prob2.nf = prob.nf+1;
    prob2.ng = 0;
    c_count = 50*ones(1,prob.ng);
    count = 0;
else
	error('No such strategy');
end
return


%
% Convert population
%
function [pop2] = convert(strategy, pop, pop2, s_param)
func = sprintf('convert%d', strategy);
pop2 = feval(func, pop, pop2, s_param);
return

%
% Update param
%
function update(strategy, pop, pop2, gen)
global s_param
if strategy == 1
	if isempty(pop)
		s_param.key = 1;
		s_param.val = 1;
		s_param.toggle = 1;
	else
		g_mean = min(pop.g, [], 2);

		% average
		%s_param = abs(mean(g_mean .* [g_mean < 0]));

		% 10 times best
		%I = find(g_mean);
		%s_param = 10 * min(abs(g_mean(I(:))));

		% average of top 20
		I = find(g_mean);
		tmp = sort(abs(g_mean(I(:))));
		s_param.val  = mean(tmp(1:20));

		s_param.toggle = s_param.toggle + 1;

		value = [0.1];
		if pop2.f1size > 0.9*pop2.size && s_param.toggle > 20
			s_param.key = s_param.key + 1;
			if s_param.key > length(value)
				s_param.key = 1;
			end
			s_param.toggle = 1;
		end
		if s_param.val < value(s_param.key)
			s_param.val = value(s_param.key);
		end
	end
elseif strategy == 2
	s_param.val = 1.e10;
elseif strategy == 4
	s_param.val = 0.01;
end
return


% 
% objectives = original, max constraint violation
% constraints = constraint threshold
%
function [pop2] = convert1(pop, pop2, s_param)
constr_threshold = s_param.val;
pop2.x = pop.x;
g_min = min(pop.g, [], 2);
pop2.f(:,1) = pop.f(:,1);
pop2.f(:,2) = abs(g_min) .* [g_min < 0];

%g_min = g_min + constr_threshold;
%pop2.g(:,1) = g_min .* [g_min < 0];
pop2.g = constr_threshold - pop2.f(:,2);

pop2.feas = [min(pop2.g, [], 2) >= 0];
pop2.rank(:,1) = pop.rank(:,1);
return


%
% objectives = original, number of constraint violations
% constraints = constraint threshold
%
function [pop2] = convert2(pop, pop2, s_param)
constr_threshold = s_param.val;
pop2.x = pop.x;
violations = [pop.g < 0];
pop2.f(:,1:pop.prob.nf) = pop.f;
pop2.f(:,pop.prob.nf+1) = sum(violations, 2);

pop2.f(:,1:pop.prob.nf) = pop.f;
pop2.f(:,pop.prob.nf+1) = sum(violations, 2);
g_min = min(pop.g, [], 2);
pop2.g = constr_threshold - abs(g_min) .* [g_min < 0];
pop2.feas = [min(pop2.g, [], 2) >= 0];
pop2.rank(:,1) = pop.rank(:,1);

return

%
% objectives = original, max constr violation
% constraints = 0
%
function [pop2] = convert3(pop, pop2, dummy)
pop2.x = pop.x;
g_min = min(pop.g, [], 2);
pop2.f(:,1:pop.prob.nf) = pop.f;
pop2.f(:,pop.prob.nf+1) = abs(g_min) .* [g_min < 0];

pop2.feas = ones(pop2.size, 1);
pop2.rank(:,1) = pop.rank(:,1);
return


%
% objectives = original, total constr violation volume
% constraints = 0
%
function [pop2] = convert4(pop, pop2, s_param)
constr_threshold = s_param.val;
pop2.x = pop.x;
tmp = [pop.g < 0];
tmp2 = [pop.g >= 0];
c = abs(pop.g .* tmp);
pop2.f(:,1) = pop.f(:,1);
pop2.f(:,2) = sum(c .* c, 2);

pop2.g = constr_threshold - pop2.f(:,2);
pop2.feas = [pop2.g >= 0];
pop2.rank(:,1) = pop.rank(:,1);

return


%
% objectives = original, constraint violation measure (rank based)
% constraints = 0
%
function [pop2] = convert5(pop, pop2, s_param)
pop2.x = pop.x;
pop2.f(:,1:pop.prob.nf) = pop.f;

tmp = [pop.g < 0];
c = pop.g .* tmp;
con_f = zeros(pop.size, pop.prob.ng);

for j = 1:pop.prob.ng
    [tmp, I] = sort(c(:,j), 'descend');
    cur_rank = 0;
    cur_val = 0;
    for i = 1:pop.size
        if tmp(i) < cur_val
            cur_rank = cur_rank+1;
            cur_val = tmp(i);
        end
        con_f(I(i), j) = cur_rank; 
    end
end

pop2.f(:,pop.prob.nf+1) = sum(con_f, 2);
pop2.feas = [min(pop.g, [], 2) >= 0];
pop2.rank(:,1) = pop.rank(:,1);

return

%
% objectives = original, constraint violation measure (exponential ranks)
% constraints = 0
%
function [pop2] = convert6(pop, pop2, s_param)
pop2.x = pop.x;
pop2.f(:,1:pop.prob.nf) = pop.f;

tmp = [pop.g < 0];
c = abs(pop.g .* tmp);
N_inf = sum(tmp, 1);
N = pop.size;
ratio = N_inf / (N-sum(pop.feas));

con_rank = zeros(pop.size, pop.prob.ng); 

% Assign weights to constraints
global c_count;
if ~isempty(pop.best) && length(pop.best.feas) > 1
    for j = 1:pop.prob.ng
        if pop.best.feas(end) == 1 && pop.best.feas(end-1) == 1
            if pop.best.g(end,j) < pop.best.g(end-1,j)
                c_count(j) = c_count(j) + 1;
            elseif pop.best.g(end,j) > pop.best.g(end-1,j)
                c_count(j) = c_count(j) - 1;
            end
            if(c_count(j) < 1), c_count(j) = 1; end
            if(c_count(j) > 100), c_count(j) = 100; end
        end
    end
end
% disp(c_count);

for j = 1:pop.prob.ng
    beta = 10^(2*ratio(j)-1);
    if beta > 1 
        c_count(j) = c_count(j) + 1;
    elseif beta < 1
        c_count(j) = c_count(j) - 1;
    end
        
    CV_max = max(c(:,j));
    if CV_max > 0
        con_rank(:,j) = c(:,j) / CV_max;
        con_rank(:,j) = con_rank(:,j) .^ (1/beta);
    end
end

pop2.f(:,pop.prob.nf+1) = sum(con_rank, 2);
pop2.feas = [min(pop.g, [], 2) >= 0];
pop2.rank(:,1) = pop.rank(:,1);

return

