function [ranks, dist] = sod_cnt_sort(pop, data, front)

F = data.F;
M = pop.prob.nf;
L = length(F(front).f);

dist = zeros(L,1);
for i =  1:L
    id1 = F(front).f(i);
    S = [];
    for j = 1:L
        if j~=i
            id2=F(front).f(j);
            S = [S; M-svd(pop,id1,id2) mepsd(pop,id1,id2)];
        end
    end
    [POS] = nd_sort(S);
    dist(i) = size(POS,1);
end

[tmp,I] = sort(dist,'descend');
ranks = F(front).f(I(:));

return

function [cnt] = svd(pop,id1,id2)
cnt = sum(pop.f(id2,:)<pop.f(id1,:));
return

function [mepsd] = mepsd(pop,id1,id2)
[ids] = find(pop.f(id2,:)>pop.f(id1,:));
if isempty(ids)
    mepsd = 0;
else
    mepsd = max(pop.f(id2,ids)-pop.f(id1,ids));
end
return
