function pop = sort(pop)
% SORT(pop)
%		pop = sort(pop) non-dominated sorting + crowding distance 

feasible = find(pop.feas == 1);
infeasible = find(pop.feas == 0);

ranks1 = [];
if ~isempty(feasible)
	front_data = non_dominated_sort(pop, feasible);
	pop.f1size = length(front_data.F(1).f);
	pop.F = front_data.F;

	for front = 1 : length(front_data.F)
		[r1, d1] = crowding_distance_sort(pop, front_data, front);
		pop.crowd(front_data.F(front).f(:)) = d1;
		ranks1 = [ranks1 r1];
	end
end

ranks2 = [];
if ~isempty(infeasible)
	ranks2 = max_constr_sort(pop, infeasible);
end

ranks = [ranks1 ranks2];
pop.rank = ranks';

% Append the best solution
global counter;
if isempty(pop.best)
	n = 1;
else
	n = length(pop.best.feas) + 1;
end

% find the id of rank1 solution (as an index in pop.rank)
id = 1;
if pop.feas(pop.rank(id)) ~= 1
	id2 = find(pop.feas(pop.rank) == 1, 1);
	if ~isempty(id2);
		id = id2;
	end
end
pop.rank1 = id;

id = pop.rank(id);
pop.best.x(n,:) = pop.x(id,:);
pop.best.f(n,:) = pop.f(id,:);
pop.best.g(n,:) = pop.g(id,:);
pop.best.feas(n) = pop.feas(id);
pop.best.f1size(n) = pop.f1size;
pop.best.fn_evals(n) = counter.fn_evals;

return
