function [NCC] = ncie(X,b)

% NCC = ncie_m(X,b);

NCC = ncie_c(X,b);

return

function [NCC] = ncie_m(X,b)

[Np, Nd] = size(X);

M = Np / b;

NCC = eye(Nd);

for i= 1:Nd
    [data{i},id{i}] = sort(X(:,i));
end

for i = 1:Nd-1
    for j = i+1:Nd
        rnk_d1 = id{i};
        rnk_d2 = id{j};
        ranks1 = zeros(Np,1);
        ranks2 = zeros(Np,1);
        for k = 1:b
            ranks1(rnk_d1((k-1)*M+1:k*M))=k;
            ranks2(rnk_d2((k-1)*M+1:k*M))=k;
        end

        rank_grid = zeros(b,b);
        tmp1 = (ranks2-1) * b + ranks1;
        for k = 1:Np
            rank_grid(tmp1(k)) = rank_grid(tmp1(k)) + 1;
        end

%         rank_grid = zeros(b,b);
%         for u= 1:Np
%             rank_grid(ranks1(u),ranks2(u)) = rank_grid(ranks1(u),ranks2(u))+1;
%         end
%         rank_grid
% 
        I = find(rank_grid ~= 0);
        NCC(i,j) = 2 + (rank_grid(I)' * log(rank_grid(I)/Np)) / (Np*log(b));
        NCC(j,i) = NCC(i,j);
    end
end

return
