%% This function Partitions Variables into Subpopulations based on
%% Correlation
function [no_sets,partitions]=partition_new(corr_mat,algo)

no_subsystems = algo.no_subsystems;

if no_subsystems == 1
    partitions.ids = 1:size(corr_mat,2);
    partitions.nvars = size(corr_mat,2);
    no_sets = 1;
    return
end

% corr_mat = abs(corr_mat);

temp11 = sum(corr_mat>= algo.threshold,2);
[temp2, temp13] = sort(temp11,'descend');


temp3 = find(temp2 == 1);
temp4 = find(temp2 ~= 1);

all_corr = {};

for j=1:length(temp3)+length(temp4)
    all_corr{j}=find((corr_mat(temp13(j),:))>=algo.threshold);
end

if sum(length(temp3))+sum(length(temp4)) <= no_subsystems
    partition_type = 1;
else
    if length(temp4) < no_subsystems
        partition_type = 2;
    elseif length(temp4) >= no_subsystems
        partition_type = 3;
    end
end

switch(partition_type)  
    case 1
        set_no = 0;
        used = [];
        for i = 1:length(temp4)+length(temp3)
            if ~isempty(setdiff(all_corr{i}, used))
                set_no = set_no + 1;
                new_elements = setdiff(all_corr{i},used);
                partitions(set_no).ids = new_elements;
                partitions(set_no).nvars = length(new_elements);
                used = [used new_elements];
            end
        end
    case 2
        for i = 1:no_subsystems
            partitions(i).ids = [];
            partitions(i).nvars = 0;
        end
        used = [];
        set_no = 0;
        for i = 1:length(temp4)
            if ~isempty(setdiff(all_corr{i}, used))
                set_no = set_no + 1;
                new_elements = setdiff(all_corr{i},used);
                partitions(set_no).ids = new_elements;
                partitions(set_no).nvars = length(new_elements);
                used = [used new_elements];
            end
        end
        rest_partitions = no_subsystems - set_no;
                
        temp31 = setdiff(1:size(corr_mat,2),used);
        if rem(length(temp31),rest_partitions)==0
            n_each = length(temp31)/rest_partitions;
            for i = 1: rest_partitions
                new_elements = setdiff([all_corr{length(temp4)+(i-1)*n_each+1: length(temp4)+i*n_each}],used);
                used = [used new_elements];
                partitions(set_no+i).ids = new_elements;
                partitions(set_no+i).nvars = length(new_elements);
            end
        else
            n_each = floor(length(temp31)/rest_partitions);
            rem_ids = rem(length(temp31),rest_partitions);
            for i = 1:rest_partitions-1
                new_elements = setdiff([all_corr{length(temp4)+(i-1)*n_each: length(temp4)+i*n_each}],used);
                used = [used new_elements];
                partitions(set_no+i).ids = new_elements;
                partitions(set_no+i).nvars = n_each;
            end
            rest_elements = setdiff([all_corr{end-(n_each+rem_ids)+1:end}],used);
            partitions(no_subsystems).ids = rest_elements;
            partitions(no_subsystems).nvars = length(rest_elements);
        end
        
    case 3
        for i = 1:no_subsystems
            partitions(i).ids = [];
            partitions(i).nvars = 0;
        end        
        used = [];
        set_no = 0;
        flag = 0;
        for i = 1:length(temp4)
            if ~isempty(setdiff(all_corr{i}, used))
                set_no = set_no + 1;
                new_elements = setdiff(all_corr{i},used);
                partitions(set_no).ids = new_elements;
                partitions(set_no).nvars = length(new_elements);
                used = [used new_elements];
                if set_no == no_subsystems-1
                   flag = 1;
                end
            end
            if flag == 1 
                break;
            end
        end
        
        
%         temp31 = setdiff(1:size(corr_mat,2),used);
        rest_partitions = no_subsystems - set_no;
        rem_ids = setdiff(1:size(corr_mat,1), used);
                
        if rem(length(rem_ids),rest_partitions)==0
            n_each = length(rem_ids)/rest_partitions;
            for i = 1:rest_partitions
                new_elements = setdiff([all_corr{set_no+(i-1)*n_each+1: set_no+i*n_each}],used);
                used = [used new_elements];
                partitions(set_no+i).ids = new_elements;
                partitions(set_no+i).nvars = length(new_elements);
            end
        else
            n_each = floor(length(rem_ids)/rest_partitions);
            no_rem_ids = rem(length(rem_ids),rest_partitions);
            for i = 1:rest_partitions-1
                new_elements = setdiff([all_corr{length(temp4)+(i-1)*n_each: length(temp4)+i*n_each}],used);
                used = [used new_elements];
                partitions(set_no+i).ids = new_elements;
                partitions(set_no+i).nvars = n_each;
            end
            rest_elements = setdiff([all_corr{end-(n_each+rem_ids)+1:end}],used);
            partitions(no_subsystems).ids = rest_elements;
            partitions(no_subsystems).nvars = length(rest_elements);
        end   
end


no_sets = length(partitions);

return