% nd_sort() - Find non-dominated points from a given set
%
function [ndset, idx] = nd_sort(set1)
[N,M] = size(set1);
dom = zeros(1,N);

for i = 1:N
	f = repmat(set1(i,:), N, 1);
	dom_less = sum(f <= set1, 2);
	dom_more = sum(f >= set1, 2);
	for j = 1:N
		if dom_less(j) == M && dom_more(j) < M
			dom(j) = dom(j) + 1;
		end
	end
end

idx = [];
for i = 1:N
	if dom(i) == 0, idx = [idx i]; end
end

ndset = set1(idx(:),:);
return
