function [c1, c2] = op_MC(x1, x2, x_min, x_max, eta_re)
% Mean Centric operator

p1 = x1;
p2 = x2;
range1 = x_min;
range2 = x_max;
scale_factor = eta_re;

if p2 < p1
    temp = p1;
    p1 =  p2;
    p2 = temp;
end

x_mean = (p1 + p2)/2;
c1 = x_mean + abs(p2-p1)*randn(1)/(6*scale_factor);
% c2 = x_mean + abs(p2-p1)*randn(1)/(6*scale_factor);
c2 = (p1+range1)/2- rand(1)*abs(p1-range1)/2 + abs(p1-range1)*randn(1)/(6*scale_factor);
c3 = (p2+range2)/2+ rand(1)*abs(range2-p2)/2 + abs(range2-p2)*randn(1)/(6*scale_factor);


if c1 <= range1
    c1 = range1;
elseif c1 >range2
    c1 = range2;
end
if c2 <= range1
    c2 = range1;
elseif c2 >range2
    c2 = range2;
end

if c3 <= range1
    c3 = range1;
elseif c3 >range2
    c3 = range2;
end

c = [c1 c2 c3];
R = randperm(3);
c1 = c(R(1));
c2 = c(R(2));

% if abs(x1-x2) > 1.e-6
%     if x2 < x1, tmp = x1; x1 = x2; x2 = tmp; end
%        
% 	r = rand(1);
% 	beta = 1 + (2 * (x1-x_min) / (x2-x1));
% 	alpha = 2 - beta^-(eta_re+1);
% 	if r <= 1/alpha
% 		betaq = (r*alpha)^(1/(eta_re+1));
% 	else
% 		betaq = (1/(2-r*alpha))^(1/(eta_re+1));
%     end
%     if betaq > 1
%         betaq = 0.75*betaq;
%     end
% % 	c1 = 0.5 * (x1+x2 - betaq*(x2-x1));
%     c1 = 0.5 * ((1-betaq)*x_min + (1+betaq)*(x1+x2)/2);
%     c2 = 0.5 * ((1+betaq)*(x_min+rand(1)*(x1-x_min)) + (1-betaq)*(x1+x2)/2);
% 
% 	beta = 1 + (2 * (x_max-x2) / (x2-x1));
% 	alpha = 2 - beta^-(eta_re+1);
% 	if r <= 1/alpha
% 		betaq = (r*alpha)^(1/(eta_re+1));
% 	else
% 		betaq = (1/(2-r*alpha))^(1/(eta_re+1));
%     end
% %     betaq = 0.85*betaq;
%     if betaq > 1 
%         betaq = 0.75*betaq;
%     end
%     c3 = 0.5 * ((1-betaq)*x_max + (1+betaq)*(x1+x2)/2);
%     c4 = 0.5 * ((1+betaq)*(x2+rand(1)*(x_max-x2)) + (1-betaq)*(x1+x2)/2);
%     
%     c = [c1 c2 c3 c4];
%     R = randperm(4);
%     c1 = c(R(1));
%     c2 = c(R(2));
%     
% 	if c1 < x_min, c1 = x_min; end
% 	if c1 > x_max, c1 = x_max; end
% 
% 	if c2 < x_min, c2 = x_min; end
% 	if c2 > x_max, c2 = x_max; end
% 
% 	if rand(1) <= 0.5, tmp = c1; c1 = c2; c2 = tmp; end
% else
% 	c1 = x1;
% 	c2 = x2;
% end

end