function [c] = op_PCX(x, range, eta, zeta)
%
%
m = size(x,2);

centroid = mean(x, 1);
diff = zeros(2, m);

for i = 1:3
	d = x(i,:) - centroid;

	flag = 0;
	for j = 1:2
		id = mod(i+j-1, 3) + 1;
		diff(j,:) = x(id,:) - x(i,:);
		if norm(diff(j,:),2) < 1.e-6
			flag = 1;
			break
		end
	end
	
	if flag == 1
		c(i,:) = x(i,:);
	else
		dist = norm(d, 2);

		for j = 1:2
			temp1 = diff(j,:) * d';
			temp2 = temp1 / norm(diff(j,:) * dist);
			temp3 = 1 - temp2^2;
			D(i) = norm(diff(j,:),2) * sqrt(temp3);
		end
		D_not = sum(D) / 2;

		tempar1 = eta * randn(1, m);
		tempar2 = tempar1 - d * (tempar1*d') / dist^2;
		tempvar = zeta * randn(1);
		c(i,:) = x(i,:) + tempar2 + tempvar * d;

		for j = 1:m
			if c(i,j) < range(j,1), c(i,j) = range(j,1); end
			if c(i,j) > range(j,2), c(i,j) = range(j,2); end
		end
	end
end

return
